
#define Version "190817"


 #define DIRECTORY  "C:\\_MikroC\\_MesProjets_MikroC\\PIC18F_ESP8266_Tests "
 #define PROJECT   "ESP8266_Base_18F26K22_tests.mcppi"
 #define SOURCE     "ESP8266_Base_18F26K22_tests_"
 #define HARDWARE  "Carte Base 18F26K22  en 28 Pins"
 #define FOSC_INTERNE
 #define FOSC "16MHz"
 #define MCU  " 18F26K22 DIP28 "
 #define POWER_SUPPLY "3.0 to 5.0V"
 #define CONFIG "P18F26K22_FOSC_interne_16Mhz.cfgsch"

#define PROCESSOR 18F26K22
#define OSCILLATEUR_INTERNE

#define BAUD 19200  // UART1
#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space



#define PCF8574_ADDR 0x4A   // PCF8574 on breadboard drives  8 leds --R--- +5V
#define DS1307_ADDR 0xD0 // RTC DS1307
#define EEPROM_32K_ADR 0xA0 // EEPROM 24LC256

#define NbCycles_T1 8


 // Hardware
 /*

 Pin 28 RB7  -----------------ICSP Data
 Pin 27 RB6  -----------------ICSP Clock
 Pin 26 RB5
 Pin 25 RB4
 Pin 24 RB3
 Pin 23 RB2
 Pin 22 RB1
 Pin 21 RB0
 Pin 20      VDD --------+5V
 Pin 19      Vss ---------Gnd
 Pin 18  RC7  RX UART  <-- Keyboard
 Pin 17  RC6  TX UART  --> Display    * mettre une pull up de 10K si RX non utilise
 Pin 16  RC5
 Pin 15  RC4  SDA

 Pin 14 RC3 SCL
 Pin 13 RC2
 Pin 12 RC1
 Pin 11 RC0
 Pin 10 RA6  --> output fOSC/4
 Pin  9 RA7
 Pin  8 VSS ---------  Gnd
 Pin  7 RA5
 Pin  6 RA4  Output -- Led -- 2,7K --+Vcc
 Pin  5 RA3
 Pin  4 RA2 (DAC)
 Pin  3 RA1  Analog input EA1
 Pin  2 RA0  Analog Input EA0
 Pin  1 RE3 MCLR  Reset --------ICSP PGRM

*/


//#include "esp8266_functions.h"


#define LCD_1602
// **********  Config Hardware **********************
//#define With_PCF8574
//#define  PCF8574_ADDR  0x4A
// PCF8574 I2C LCD Port Definition
// P7,P6,P5,P4 = Data, P3=Backlight (BL), P2=E, P1=RW, P0=RS
#define LCD_BL 0x08
#define LCD_EN 0x04
#define LCD_RW 0x02
#define LCD_RS 0x01





#include "built_in.h"     // for  Hi  Lo ..etc
#define LCD_1602_I2C
#include "LCD_Definitions.h"
#include "Lib_LCD1602_I2C.h"

const char chaine0[]=" Directory: "DIRECTORY"\r\n";
const char chaine1[]=" Projet : "PROJECT "\r\n";
const char chaine2[]=" Alim. = "POWER_SUPPLY"\r\n";
const char chaine3[]=" CONFIG : "CONFIG"\r\n";
const char chaine4[]=" FOSC interne "FOSC"\r\n";
const char chaine5[]=" Port Hard UART1 19200,N,8,1 (RC6=TX RC7=RX) \r\n";
const char chaine6[]=" LCD 2x16 sur PCF8574-1 \r\n";
const char chaine7[]=" \r\n";
const char chaine8[]=" Source "SOURCE"_"Version".c\r\n" ;
const char chaine9[]="   \r\n";
const char chaine10[]="   \r\n";
const unsigned char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5 ,chaine6,chaine7,chaine8,chaine9,chaine10};
const code char mesg0[]="                   ";

sbit  Led_On_RA4 at LATA.B4;      //tirage au +VCC via 2,7K
sbit  Led_On_RA4_Direction at TRISA.B4 ;
#define ON 0
#define OFF 1

#define MAXLEN1 80
volatile unsigned char buffer1[MAXLEN1];
volatile int Flag_Buffer1;
volatile  unsigned char c1;
volatile unsigned int i1;
volatile int Index1;
volatile unsigned int CptErr;
volatile unsigned int Count1;
volatile unsigned int Count2;
volatile int Flag_Timer1;
volatile int Flag_Timer2;

int i,j,k,l;
unsigned  char TEXTE[64];
unsigned char * txt;
char CRam1[32];   // for flot2asccii use
 float f1,f2;
 
 
unsigned char Addr;
unsigned char LCD_ADDR;


 /*

extern unsigned char I2C_PCF8574_Write(unsigned char  Adr,unsigned char value);
extern  void LCD_init_4x20(void);
extern void LCD_putcmd(unsigned char d,unsigned char cmdtype);
extern void LCD_putch(unsigned char d);
extern void LCD_puts(char *s);
extern void LCD_putsRom(code char *s);
extern void LCD_Msg_Status(const char* T);  // affiche un TEXTE en ligne 4
extern void LCD_Write_CText(const char *txt) ;
extern void LCDHandler(char c);
char check_device(unsigned int dev_address);
void Ecriture_PCF8574(short int k) ;
unsigned char Lecture_PCF8574(void);
 */
void strConstRamCpy(unsigned char *dest, const code char *source);
void CRLF1(void);
void UART1_Write_CText(const char *txt);
void Init_Hardware(void) ;



void Interrupts() iv 0x0008 ics ICS_AUTO
{
if ( (RCIE_bit) && ( RCIF_bit))
   {  
   
      c1 = RCREG;
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }

     if ((c1==CR) || (i1>MAXLEN1-2))
      {
      Flag_Buffer1=1;
      //PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        buffer1[i1]=c1;
        Index1=i1;
        i1++;

      }
     PIR1.RCIF=0   ;
   }
  // ------  timer 1  ----------------
  if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag

     Count1++;
     if (Count1>=NbCycles_T1)   // 8x125 ms= 1 seconde   et init timer1  3035  et prescaler=1/8
       {
        Count1=0;
        Flag_Timer1=1;
        TMR1IE_bit=0;
      }
      TMR1H= 0x0B; // Hi (3035);
      TMR1L= 0xDB; // Lo (3035);
      PIR1.TMR1IF=0;
   }
   /*
   ------  timer 2 ----------------
  if( ((TMR2IE_bit==1)&& TMR2IF_bit==1))
  {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag

     Count2++;
     if (Count2>=NbCycles_T2)   // 8x125 ms= 1 seconde   et init timer1  3035  et prescaler=1/8
       {
        Count2=0;
        Flag_Timer2=1;
      }
      TMR2= 60;
      PIR1.TMR2IF=0;
   }
   */
 }



void Init_Timer1(void)
 {
  T1CON=0;
 // T1CON=0b00110000;
  TMR1CS0_bit=0;   // FOSC internal / 4
  TMR1CS1_bit=0;
  T1CKPS1_bit=1;  //prescal select=11 => 1/8
  T1CKPS0_bit=1;
  T1GCON=0;
  TMR1H= 0x0B; // Hi (3035);
  TMR1L= 0xDB; // Lo (3035);
 // TMR1H= NbCycles_T1>>8;
 // TMR1L= NbCycles_T1 & 0x00FF;
   Count1=0;
  Flag_Timer1=0;
  PIR1.TMR1IF=0;     // Reset Timer1 Flag
  PIE1.TMR1IE=1;  //Enable interrupt TMR1
  TMR1ON_bit=1;
}


 void Init_Timer2(void)
 {
  T2CON=0;
  T2OUTPS0_bit=1;     // postscaleer =1/16
  T2OUTPS1_bit=1;
  T2OUTPS2_bit=1;
  T2OUTPS3_bit=1;
  T2CKPS1_bit=1;  //prescaler select=11 => 1/64
  T2CKPS0_bit=1;
  TMR2=   60;     // 49.92mS @ 16MHz
  Count2=0;
  Flag_Timer2=0;
  TMR2IF_bit=0;     // Reset Timer1 Flag
  TMR2IE_bit=0;  //Enable interrupt TMR1
  TMR2ON_bit=1;
}

// * --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void Binarise (unsigned char k)
{
 int i,j  ;
 j=128;
 for (i=0; i<8;i++)
 {
   if ((k & j)==j)
   {
     UART1_Write('1');
     k=k-j;
   }
   else
   UART1_Write('0');
   j=j>>1;
 }
}

 void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

char check_device(unsigned int dev_address)
{
char cx=0;
I2C1_Start();
 if (I2C1_Wr(dev_address))
 {
  sprintf(txt,"Device at adresse % 3d soit  %02X  is not found",dev_address,dev_address);
   UART1_Write_Text(txt);
   cx=0;
   
 }
 else
 {
  sprintf(txt,"Device at adresse % 3d soit  %02X \t\t found OK",dev_address,dev_address);
   UART1_Write_Text(txt);
   cx=dev_address;
  }
I2C1_Stop();
 CRLF1();
 return cx;
}

unsigned char Lecture_PCF8574(void)
{ unsigned char cc;
 char S,dummy;
   I2C1_Start();
   S=I2C1_Wr(LCD_ADDR+1); //PCF8574_ADDR+1);        // send port expander address  A2=0 , A1=0, A=0  , R/W=1
   if(S == 0)        //check if bus collision happened
  {
    dummy = SSPBUF;        //upon bus collision detection clear the buffer,
    SSPCON1.WCOL=0;    // clear the bus collision Etat bit
  }
   cc=I2C1_Rd(0);
   I2C1_Stop();
   return cc;
  }


 void Init_Hardware()
{
  PORTB = 0xFF;
  TRISB = 0x83;    //  B0,B1 as input   ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;

  PORTA = 0b00000111;
  ANSELA=0;
  ANSELA.ANSA0=1;    //  analog input on Port A   voir page 154
  ANSELA.ANSA1=1;
  TRISA = 0b00001111 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3,4,5=Digital output
  PORTA=0;
  Led_On_RA4_Direction=0;
  Led_On_RA4=OFF;

  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;
  TRISC = 0x80;    //
  TRISC.TRISC3 = 1;  // SCL I2C
  TRISC.TRISC4 = 1;  // SDA I2C
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1
  //PORTC = 0x40;      // RC0..RC5,RC7 = input RC6=Output

  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }


void main()
{

  #ifdef OSCILLATEUR_INTERNE

    // 16MHz
  //OSCCON.IRCF2=1;
  //OSCCON.IRCF1=1;
  OSCCON.IRCF0=1;
  //8Mhz
  OSCCON.IRCF2=1;
  OSCCON.IRCF1=1;
  //OSCCON.IRCF0=0;

  OSCCON.SCS1=1;  // internal oscillator block
  OSCCON.SCS0=0;
  while(OSCCON.HFIOFS==0);
  #endif

  Init_Hardware();
  
  for(i=0;i<5;i++)
  {
  Led_On_RA4=ON;
  Delay_ms(500);
   Led_On_RA4=OFF;
    Delay_ms(500);
  }

   txt=&TEXTE[0];

  UART1_Init(19200);
  Delay_ms(100);
  while (UART1_Tx_Idle() == 1) UART1_Write(13);     // vide le buffer
  UART1_Write(CLS);    // efface l'ecran VBRAY

  CRLF1();
  UART1_Write_CText(" Init UART1 19200,8,N,1\r\n");
  UART1_Write_CText(" Mikroc Pro 7.50\r\n");
  UART1_Write_CText(" Source :"SOURCE"_" Version".c\r\n");
  UART1_Write_CText(" Hardware : "HARDWARE"\r\n");
  UART1_Write_CText(" LCD 2x16 sur bus I2C1 \r\n");
  UART1_Write_CText(" UART1 via USB -> COM3 19200,8,N,1 YAT Terminal\r\n");
  UART1_Write_CText(" Test LCD 1602 2x16 en I2C via PCF8754 additionnel\r\n\r\n");

  /*
   _______________  TEST ZONE ________________________________
   CRLF1();
  c1=~0x04;
  //c1=~c1;
  ByteToStr(c1,CRam1);
  UART1_Write_Text(CRam1);
  UART1_Write(TAB);
  ByteToHex(c1,CRam1);
   UART1_Write_Text(CRam1);
  CRLF1();
   ___________________________________________________

  */

  #ifdef TEST_FOSC
  Freq = Clock_kHz();
  UART1_Write_CText(" Fosc =");
  LongWordToStr(Freq, txt) ;
  UART1_Write_Text(txt);
  UART1_Write_CText(" KHz\r\n");
  UART1_Write_CText(" Check delay de 5000mS entre # et @\r\n");
  UART1_Write('#');  CRLF1();
  #ifndef DEBUGGING
  Delay_ms(5000);
  #endif
  UART1_Write('@');  CRLF1();
  #endif


  UART1_Write_CText(" Init I2C1 400Khz\r\n");
  I2C1_Init(400000); // Initialisation de l'I2C
  Delay_ms(500);





  i=0x30;
  while(i<128)
  {

   if ((check_device(i)>0) &&( i<128))break ;
   Delay_ms(50);
   i=i+2;
   }
   Delay_ms(100);

  // PCF8574 on pigboard YwRobot back located  on Big LCD 4x20   LCD_ADR=0x4E=78;
  // @ maxi=0x40 + les  3 strap adresse ouverts   = 111+0 => 0x4E
  // LCD_ADR=0x4E;   //   base gros LCD4x20  + PCF8754= 0x4E

  //   base LCD1602  2x16 + PCF8754= 0x40 + 3bits adresse  =0x4A= 74
   Addr=i; 
   LCD_ADDR=0x4A;
   UART1_Write_CText(" Init Display LCD 2x16 : ");
   LCD_Init_2x16();
   CRLF1();
   LCD_putch(LCD_CLEAR);

   Delay_ms(300);

     UART1_Write_CText(" Ecrit. sur 1ere ligne du LCD : ");
     strConstRamCpy(txt,"Hello I am alive");
     UART1_Write_Text(txt);
     CRLF1();
     Erase_Line(1);
     LCD_Write_CText("Hello I am alive") ;
     Delay_ms(2000);

     UART1_Write_CText(" Ecrit. sur 2em ligne du LCD : ");
     strConstRamCpy(txt,"paulfjujo 012345");
     UART1_Write_Text(txt);
     CRLF1();
     Erase_Line(2);
      LCD_Write_Text(txt) ;
      Delay_ms(2000);
     
     Erase_Line(2);
     Erase_Line(1);
     LCD_Write_CText("paulfjujo.free.f") ;
      Delay_ms(2000);
   j=0;
  do
  {
    Erase_Line(2);
    LCD_Write_CText("Compteur J=     ") ;
    WordToStr(j,CRam1);
    //Ltrim(CRam1);
    //k=strlen(CRam1);
    LCD_putcmd(LCD_LINE2+11,1);
    LCD_Write_Text(CRam1);
    j++;
    Delay_ms(1000);
    }
    while(1);



}
/*
 Init UART1 19200,8,N,1
 Mikroc Pro 7.50
 Source :ESP8266_Base_18F26K22_tests.c  _190816.c
 Hardware : Carte Base 18F26K22  en 28 Pins
 LCD 2x16 sur bus I2C1
 UART1 via USB -> COM3 19200,8,N,1 YAT Terminal
 Test LCD 1602 2x16 en I2C via PCF8754 additionnel

 Init I2C1 400Khz
Device at adresse  48 soit  30  is not found
Device at adresse  50 soit  32  is not found
Device at adresse  52 soit  34  is not found
Device at adresse  54 soit  36  is not found
Device at adresse  56 soit  38  is not found
Device at adresse  58 soit  3A  is not found
Device at adresse  60 soit  3C  is not found
Device at adresse  62 soit  3E  is not found
Device at adresse  64 soit  40  is not found
Device at adresse  66 soit  42  is not found
Device at adresse  68 soit  44  is not found
Device at adresse  70 soit  46  is not found
Device at adresse  72 soit  48  is not found
Device at adresse  74 soit  4A                  found OK
 Init Display LCD 2x16 :   0123456789

 Ecrit. sur 1ere ligne du LCD : Hello I am alive
 Ecrit. sur 2em ligne du LCD : paulfjujo 012345

  */