
#include "LCD_Definitions.h"
#include "Lib_LCD1602_I2C.h"

#define Debug_Init

extern unsigned char * txt;
extern unsigned char Addr;
/*
unsigned char I2C_PCF8574_Write(unsigned char  Adr,unsigned char value);
void LCD_Init_2x16(void);
void Erase_Line(int L);
void LCD_putcmd(unsigned char d,unsigned char cmdtype);
void LCD_putch(unsigned char d);
void LCD_putsRom(code char *s);
void LCD_Write_Text(char *s);
void LCD_Write_CText(const char *txt) ;
 void LCD_Clear(void)
*/

 //========== LCD 4x20 sur bus I2C ================================
  /*
  PCF8574 I2C LCD Routine
  LCD Data PCA8574: P7,P6,P5,P4
  LCD Control: P3: Back Light, P2: E-Enable, P1:RW, P0: RS
*/

 unsigned char I2C_PCF8574_Write(unsigned char ad,unsigned char value)
{
signed char S;
unsigned char dummy;
 I2C1_Start();
 S = I2C1_Wr( Addr );
 if(S == -1)        //check if bus collision happened
        {
       dummy = SSP1BUF;        //upon bus collision detection clear the buffer,
      // SSPCON1.WCOL=0;    // clear the bus collision status bit
       SSPCON1.WCOL=0;    // clear the bus collision status bit
        }
S = I2C1_Wr(value);
I2C1_Stop();
return(S);
}

void Erase_Line(int L)
{
switch(L)
 {
 case 1:
  {
   LCD_putcmd(LCD_LINE1,1);
     LCD_Write_CText("                ");
   LCD_putcmd(LCD_LINE1,1);
   break;
  }
  case 2:
  {
   LCD_putcmd(LCD_LINE2,1);
   LCD_Write_CText("                ");
   LCD_putcmd(LCD_LINE2,1);
    break;
  }
 /*
  case 3:
  {
   LCD_putcmd(LCD_LINE3,1);
   LCD_Write_CText("                ");
   LCD_putcmd(LCD_LINE3,1);
    break;
  }
  case 4 :
  {
   LCD_putcmd(LCD_LINE4,1);
   LCD_Write_CText(mesg0);
   LCD_putcmd(LCD_LINE4,1);
    break;
  }
  */
 }
}


void LCD_putcmd(unsigned char d,unsigned char cmdtype)
{ int Etat;
  unsigned char lcddata;
  // Put the Upper 4 bits data
  lcddata = (d & 0xF0)|LCD_BL;
  Etat=I2C_PCF8574_Write(Addr,lcddata | LCD_EN);
  Delay_us(50);
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(Addr,lcddata & ~LCD_EN);
  Delay_us(50);      // Delay 1us for 16 MHz Internal Clock
  // cmdtype = 0; One cycle write, cmdtype = 1; Two cycle writes
  if (cmdtype==1) 
  {
    // Put the Lower 4 bits data
    lcddata = ((d << 4) & 0xF0)|LCD_BL;
    Etat=I2C_PCF8574_Write(Addr,lcddata | LCD_EN);
    Delay_us(10);    // Delay 2us for 16 MHz Internal Clock
    // Write Enable Pulse E: Hi -> Lo
    Etat=I2C_PCF8574_Write(Addr,lcddata & ~LCD_EN);
    Delay_ms(5);    // Delay 1us for 16 MHz Internal Clock
  }
}

void LCD_putch(unsigned char d)
{
  unsigned char lcddata;
  int Etat;
  // Put the Upper 4 bits data
  lcddata = (d & 0xF0)|LCD_BL|LCD_RS;
  Etat=I2C_PCF8574_Write(Addr,lcddata | LCD_EN);
  Delay_us(10);      // Delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(Addr,lcddata & ~LCD_EN);
  Delay_us(10);      // Delay 1us for 16 MHz Internal Clock
  // Put the Lower 4 bit data
  lcddata = ((d << 4) & 0xF0)|LCD_BL|LCD_RS;
  Etat=I2C_PCF8574_Write(Addr,lcddata | LCD_EN);
  Delay_us(10);      // Delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(Addr,lcddata & ~LCD_EN);
  Delay_us(25);      // Delay 1us for 16 MHz Internal Clock
}

void LCD_Init_2x16(void)
{ 
#ifdef Debug_Init
   UART1_Write(' ');    // space
    UART1_Write(32);    // space
   UART1_Write('0');
 #endif
  // Wait for more than 15 ms after VCC rises to 4.5 V
  Delay_ms(100);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
 #ifdef Debug_Init
  UART1_Write('1');
  #endif
  // Wait for more than 4.1 ms
  Delay_ms(25);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
#ifdef Debug_Init
  UART1_Write('2');
  #endif
  // Wait for more than 100 us
  Delay_ms(25);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
#ifdef Debug_Init
  UART1_Write('3');
  #endif
  Delay_ms(25);
// Function set: Set interface to be 4 bits long (only 1 cycle write).
  LCD_putcmd(0x25,0);
#ifdef Debug_Init
   UART1_Write('4');
   #endif
    Delay_ms(20);
  // Function set: DL=0 Interface is 4 bits, N=1  2 Lines, F=0  5x8 dots font)
    LCD_putcmd(0x28,1);
#ifdef Debug_Init
  UART1_Write('5');
  #endif
    Delay_ms(2);
  LCD_putcmd(0x08,1);    //0x08
#ifdef Debug_Init
  UART1_Write('6');
  #endif
    Delay_ms(2);
  // Display Clear
  LCD_putcmd(LCD_CLEAR,1);
#ifdef Debug_Init
  UART1_Write('7');
  #endif
    Delay_ms(20);
  // Entry Mode Set: I/D=1    increment X when Char input ;  S=0 No shift
  LCD_putcmd(0x06,1);
#ifdef Debug_Init
  UART1_Write('8');
  #endif
    Delay_ms(2);
  // Display On, Cursor Off
  LCD_putcmd(0x0C,1);
#ifdef Debug_Init
  UART1_Write('9');
   UART1_Write(13);
    UART1_Write(10);
#endif
    Delay_ms(2);
}

void LCD_Write_Text( char *s)
{int i=0;
  while((*s != 0)&& (i<16))
  {
    LCD_putch(*s);
    s++;   i++;
  }
}

void LCD_Write_CText(const char *tx)
{
   while (*tx)
   LCD_putch(*tx++);
 }
 
 
 void LCD_Clear(void)
 {
  LCD_putcmd(LCD_CLEAR,1);
  
  }